/* Copying and distribution of this file, with or without modification,
 * are permitted in any medium without royalty provided the copyright
 * notice and this notice are preserved.  This file is offered as-is,
 * without any warranty.
 */


module converter;
/**
 * Converts formats.csv to fileformats.dtxt with 2D array in D
 */

import std.algorithm, std.array, std.conv, std.csv, std.file;
import std.stdio, std.string, std.typecons;

int main(string[] args) {
    if (args.length != 2 ) {
        stderr.writeln("Wrong using of the program.");
        return 1;
    }
    string csvText = readText(args[1]);
    string arrayText;
    foreach(record; csvReader!(string[string])(csvText, null)) {
        string hexSignatureArrayView;
        foreach(el; record["SIGNATURE"].split(' ')) {
            if (el.strip.empty) continue;
            hexSignatureArrayView ~= "0x" ~ el ~ ",";
        }
        if (hexSignatureArrayView.length > 2) {
            hexSignatureArrayView = hexSignatureArrayView.stripRight(',');
            hexSignatureArrayView = "[" ~ hexSignatureArrayView ~ "]";
        } else {
            hexSignatureArrayView = "null";
        }
        string extensionsArrayView;
        foreach(el; record["EXTENSIONS"].split(' ')) {
            el = el.stripRight(',');
            extensionsArrayView ~= `"`~el~`", `;
        }
        if (extensionsArrayView.length > 2) {
            extensionsArrayView = extensionsArrayView.strip.stripRight(',');
            extensionsArrayView = "[" ~ extensionsArrayView ~ "]";
        } else {
            extensionsArrayView = "null";
        }
        string newTextFragment = format(
            `%s(%s, %s, "%s", "%s", %s, "%s"),`~"\n",
            "FileFormat",
            hexSignatureArrayView,
            record["OFFSET"],
            record["FORMAT"],
            record["DESCRIPTION"],
            extensionsArrayView,
            record["CATEGORY"]
        );
        arrayText ~= newTextFragment;
    }
    arrayText = "[\n" ~ arrayText[0 .. $-1] ~ "\n];"; //without last comma
    std.file.write("fileformats.dtxt", arrayText);
    return 0;
}
